service.playSoundScroll()
require "import"
import "android.speech.RecognizerIntent"
import "android.content.Intent"
import "android.net.Uri"
import "android.speech.tts.TextToSpeech"

tts = TextToSpeech(service, nil)

-- Prefixe internaționale pentru toate țările
prefixes = {
    ["afganistan"] = "+93", ["africa de sud"] = "+27", ["albania"] = "+355", ["algeria"] = "+213",
    ["andorra"] = "+376", ["angola"] = "+244", ["anguilla"] = "+1-264", ["antigua și barbuda"] = "+1-268",
    ["arabia saudită"] = "+966", ["argentina"] = "+54", ["armenia"] = "+374", ["aruba"] = "+297",
    ["australia"] = "+61", ["austria"] = "+43", ["azerbaidjan"] = "+994", ["bahamas"] = "+1-242",
    ["bahrain"] = "+973", ["bangladesh"] = "+880", ["barbados"] = "+1-246", ["belarus"] = "+375",
    ["belgia"] = "+32", ["belize"] = "+501", ["benin"] = "+229", ["bermuda"] = "+1-441",
    ["bhutan"] = "+975", ["bolivia"] = "+591", ["bosnia și herțegovina"] = "+387", ["botswana"] = "+267",
    ["brazilia"] = "+55", ["brunei"] = "+673", ["bulgaria"] = "+359", ["burkina faso"] = "+226",
    ["burundi"] = "+257", ["cambodgia"] = "+855", ["camerun"] = "+237", ["canada"] = "+1",
    ["capul verde"] = "+238", ["cehia"] = "+420", ["chile"] = "+56", ["china"] = "+86",
    ["cipru"] = "+357", ["columbia"] = "+57", ["comore"] = "+269", ["congo"] = "+242",
    ["coreea de nord"] = "+850", ["coreea de sud"] = "+82", ["costa rica"] = "+506", ["croația"] = "+385",
    ["cuba"] = "+53", ["danemarca"] = "+45", ["djibouti"] = "+253", ["dominica"] = "+1-767",
    ["ecuador"] = "+593", ["egipt"] = "+20", ["el salvador"] = "+503", ["emiratele arabe unite"] = "+971",
    ["eritreea"] = "+291", ["estonia"] = "+372", ["etiopia"] = "+251", ["fiji"] = "+679",
    ["filipine"] = "+63", ["finlanda"] = "+358", ["franța"] = "+33", ["gabon"] = "+241",
    ["gambia"] = "+220", ["georgia"] = "+995", ["ghana"] = "+233", ["gibraltar"] = "+350",
    ["grecia"] = "+30", ["guatemala"] = "+502", ["guineea"] = "+224", ["guineea-bissau"] = "+245",
    ["haiti"] = "+509", ["honduras"] = "+504", ["hong kong"] = "+852", ["india"] = "+91",
    ["indonezia"] = "+62", ["irak"] = "+964", ["iran"] = "+98", ["irlanda"] = "+353",
    ["islanda"] = "+354", ["israel"] = "+972", ["italia"] = "+39", ["jamaica"] = "+1-876",
    ["japonia"] = "+81", ["kazahstan"] = "+7", ["kenya"] = "+254", ["kirghizstan"] = "+996",
    ["kiribati"] = "+686", ["kuweit"] = "+965", ["laos"] = "+856", ["letonia"] = "+371",
    ["liban"] = "+961", ["liberia"] = "+231", ["libia"] = "+218", ["liechtenstein"] = "+423",
    ["lituania"] = "+370", ["luxemburg"] = "+352", ["macao"] = "+853", ["macedonia de nord"] = "+389",
    ["madagascar"] = "+261", ["malawi"] = "+265", ["malaezia"] = "+60", ["maldive"] = "+960",
    ["mali"] = "+223", ["malta"] = "+356", ["maroc"] = "+212", ["mauritania"] = "+222",
    ["mexic"] = "+52", ["moldova"] = "+373", ["monaco"] = "+377", ["mongolia"] = "+976",
    ["muntenegru"] = "+382", ["mozambic"] = "+258", ["namibia"] = "+264", ["nauru"] = "+674",
    ["nepal"] = "+977", ["nicaragua"] = "+505", ["niger"] = "+227", ["nigeria"] = "+234",
    ["norvegia"] = "+47", ["noua zeelandă"] = "+64", ["oman"] = "+968", ["pakistan"] = "+92",
    ["palau"] = "+680", ["panama"] = "+507", ["papua noua guinee"] = "+675", ["paraguay"] = "+595",
    ["peru"] = "+51", ["polonia"] = "+48", ["portugalia"] = "+351", ["qatar"] = "+974",
    ["românia"] = "+40", ["rusia"] = "+7", ["san marino"] = "+378", ["senegal"] = "+221",
    ["serbia"] = "+381", ["singapore"] = "+65", ["slovacia"] = "+421", ["slovenia"] = "+386",
    ["spania"] = "+34", ["statele unite"] = "+1", ["sudan"] = "+249", ["suedia"] = "+46",
    ["tailanda"] = "+66", ["taiwan"] = "+886", ["tanzania"] = "+255", ["tunisia"] = "+216",
    ["turcia"] = "+90", ["ucraina"] = "+380", ["ungaria"] = "+36", ["uruguay"] = "+598",
    ["uzbekistan"] = "+998", ["vatican"] = "+379", ["venezuela"] = "+58", ["vietnam"] = "+84"
}

function startVoiceRecognition()
    intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ro-RO")
    intent.putExtra(RecognizerIntent.EXTRA_PROMPT, "Spune numărul de telefon...")

    activity.startActivityForResult(intent, 1)
end

function onActivityResult(requestCode, resultCode, data)
    if requestCode == 1 and resultCode == activity.RESULT_OK then
        results = data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS)
        input = results.get(0):lower()

        country, phoneNumber = extractCountryAndNumber(input)

        if not phoneNumber:match("^%+") then
            phoneNumber = (prefixes[country] or prefixes["românia"]) .. phoneNumber
        end

        tts.speak("Numărul recunoscut este: " .. phoneNumber, TextToSpeech.QUEUE_FLUSH, nil)

        task(2000, function()
            callOnWhatsApp(phoneNumber)
        end)
    end
end

function extractCountryAndNumber(input)
    for country, _ in pairs(prefixes) do
        if input:find(country) then
            return country, input:gsub(country, ""):gsub("%s+", "")
        end
    end
    return "românia", input:gsub("%s+", "")
end

function callOnWhatsApp(phoneNumber)
    uri = Uri.parse("https://api.whatsapp.com/send?phone=" .. phoneNumber)
    intent = Intent(Intent.ACTION_VIEW, uri)
    intent.setPackage("com.whatsapp")

    if intent.resolveActivity(activity.getPackageManager()) ~= nil then
        activity.startActivity(intent)
    else
        tts.speak("WhatsApp nu este instalat.", TextToSpeech.QUEUE_FLUSH, nil)
    end
end

startVoiceRecognition()